/*-
 * Copyright (C) @BABOLO  2008 Mar 16 http://www.babolo.ru/
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 *  OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: ipclassify.h,v 1.2 2010/07/30 14:08:13 babolo Exp $
 */

typedef struct ipclassify_er {
    u_int32_t mask;
    u_int32_t value;
    u_int32_t eq;
    u_int32_t neq;
} ipclassify_er;

typedef struct ipclass_btail {
    u_int32_t      flags;   /*                                          */
#   define IPCLASS_I 0x0001 /*                          */
#   define IPCLASS_O 0x0002 /*                         */
#   define IPCLASS_T 0x0004 /*   ipaggr  t             */
#   define IPCLASS_F 0x0008 /*   ipaggr  f             */
#   define IPCLASS_C 0x0010 /*            */
#   define IPCLASS_P 0x0020 /*                       */
    int            fout;    /*                       */
    size_t         stree;   /*                  */
    size_t         ltree;   /*       */
    size_t         ptree;   /*                */
    ipclassify_er *ip_tree; /*                      */
    ssize_t        filin;   /*   ipaggr                        */
    size_t         tpoint;  /*     ipaggr         */
    u_char        *plain;   /*   ipaggr                         */
    u_int32_t      true;    /*  t            */
    u_int32_t      false;   /*  f            */
    u_int32_t      eq;      /*                                   */
    u_int32_t      neq;     /*                                   */
} ipclass_btail;
